import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class B {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("calculation.in"));
		FileWriter writer = new FileWriter("calculation.out");

		String[] input = reader.readLine().split(" ");
		final int[] coinValues = new int[] {5, 10, 20, 50};
		int[] coins = new int[4];
		for(int i = 0; i < 4; i++)
			coins[i] = Integer.parseInt(input[i]);
		int sum = Integer.parseInt(input[4]);
		
		if(sum % 5 != 0) {
			writer.write("-1");
			writer.write(System.lineSeparator());
			writer.close();
			reader.close();
			return;
		}

		int totalCoinsSpent = 0;
		int[] coinsSpent = new int[4];
		
		for(int i = 3; i >= 0; i--) {
			int spent = sum / coinValues[i];
			if(spent > coins[i])
				spent = coins[i];
			totalCoinsSpent += spent;
			coinsSpent[i] += spent;
			sum -= spent * coinValues[i];
		}
		
		if(sum > 0) {
			writer.write("-1");
			writer.write(System.lineSeparator());
			writer.close();
			reader.close();
			return;
		}
		
		for(int i = 0; i < 4; i++) {
			writer.write(Integer.toString(coinsSpent[i]));
			writer.write(' ');
		}
		writer.write(Integer.toString(totalCoinsSpent));
		writer.write(System.lineSeparator());
		writer.close();
		reader.close();
	}
}
