import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.CharBuffer;
import java.util.Arrays;
import java.util.Stack;


public class C {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("strings.in"));
		FileWriter writer = new FileWriter("strings.out");
		
		String input = reader.readLine();
		int stringLength = Integer.parseInt(input);
		char[] c = new char[stringLength];
		reader.read(c);
		maxScores = new int[stringLength];
		
		jump(0, c, 0);
		
		writer.write(Integer.toString(maxScores[stringLength - 1]));
		writer.write(System.lineSeparator());
		
		writer.close();
		reader.close();
	}
	
	static int[] maxScores = new int[0];
	
	static void jump(int i, char[] chars, int currentScore) {
		for(int i2 = i; i2 < chars.length; i2++) {
			if(chars[i2] == chars[i])
				continue;
			
			int cDiff = chars[i2] - chars[i];
			if(cDiff < 0)
				cDiff = -cDiff;
			
			int newScore = currentScore + cDiff * (i2 - i);
			if(newScore > maxScores[i2]) {
				maxScores[i2] = newScore;
				jump(i2, chars, newScore);
			}
		}
	}
}
