#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <fstream>


using namespace std;
typedef long long ll;
const int maxn = 300000;
struct vertex{
    int first, l, r;
    char second;
};
vertex seg_tree[4*maxn];
string d;
ll len(int x){
    return x * (x + 1) / 2;
}
vertex operator+( vertex a, vertex b){
        vertex ret;
    if(a.r && b.l){
        ret.first = a.first + b.first - len(a.r) - len(b.l) + len(a.r + b.l);
    }
    else ret.first = a.first + b.first;
    if(a.second == 'B')
        ret.l = a.l + b.l;
    else ret.l = a.l;
    if(b.second == 'B')
        ret.r = a.r + b.r;
    else ret.r = b.r;
    if(a.second == 'B' && b.second == 'B')
        ret.second = 'B';
    else ret.second = 'N';
    return ret;
}
void build(int v, int l, int r){
      if(l == r){
        if(d[l] == '1'){
            seg_tree[v].first = 1;
            seg_tree[v].l = 1;
            seg_tree[v].r = 1;
            seg_tree[v].second = 'B';

        }
        else{
            seg_tree[v].first = 0;
            seg_tree[v].l = 0;
            seg_tree[v].r = 0;
            seg_tree[v].second = 'N';
        }
      }
      else{
        int m = l - (l - r) / 2;
        build(2*v, l, m);
        build(2 * v + 1, m + 1, r);
        seg_tree[v] = seg_tree[2 * v] + seg_tree[2*v + 1];
      }
}
int get(){
    int k = seg_tree[1].first;
    return k;
}
void update(int v, int Tl, int Tr, int l, int r, int x){
        if(l > r)
            return;
        if(Tl == l && Tr == r){
        if(x){
                seg_tree[v].second = 'B';
                seg_tree[v].r = seg_tree[v].l = r - l + 1;
                seg_tree[v].first = len(r - l + 1);
            }
            else{
                seg_tree[v].second = 'N';
                seg_tree[v].r = seg_tree[v].l = 0;
                seg_tree[v].first = 0;
            }
        }
        else{
            int m = Tl - (Tl - Tr) / 2;
            update(2 * v, Tl, m, l, min(m,r), x);
            update(2 * v + 1, m + 1, Tr, max(l, m+1), r, x);
            seg_tree[v] = seg_tree[2 * v] + seg_tree[2 * v + 1];
        }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("lanterns.in", "r", stdin);
    //freopen("lanters.out", "w", stdout);
    int n, q;
    cin >> n >> q;
    cin >> d;
    build(1, 0, n - 1);
    cout << get() << '\n';
    int l,r, C;
    for(int i = 0; i < q; ++i){
        cin >> l >> r >> C;
        update(1,0,n - 1, l - 1, r - 1, C);
        cout << get() << '\n';
    }
    return 0;
}
