import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

public class E {
	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(
				new FileReader("lanterns.in"));
		FileWriter writer = new FileWriter("lanterns.out");

		String[] input = reader.readLine().split(" ");
		int lanternsCount = Integer.parseInt(input[0]);
		int eventsCount = Integer.parseInt(input[1]);
		// HashMap<Integer, Segment> map = new HashMap();
		ArrayList<Segment> map = new ArrayList();
		Segment currentSegment = null;
		for (int i = 0; i < lanternsCount; i++) {
			int read = reader.read();
			if (read == '1' && currentSegment == null) {
				Segment s = new Segment(-1, -1);
				s.start = i;
				map.add(s);
				currentSegment = s;
			} else if (read == '0' && currentSegment != null) {
				currentSegment.end = i - 1;
				currentSegment = null;
			}
		}
		if (currentSegment != null)
			currentSegment.end = lanternsCount - 1;
		reader.readLine();

		for (int event = 0; event < eventsCount; event++) {
			input = reader.readLine().split(" ");
			int start = Integer.parseInt(input[0]);
			int end = Integer.parseInt(input[1]);
			int type = Integer.parseInt(input[2]);
			if (type == 1) {
				boolean deleteRest = false;
				for (Segment s : map) {
					if (s.intersects(start, end)) {
						if (deleteRest)
							s.makeInvalid();
						else {
							if (s.start < start && s.end <= end) {
								s.end = end;
							} else if (s.end > end && s.start >= start) {
								s.start = start;
							} else {
								s.makeInvalid();
							}
						}
					}
				}
			} else {
				for (Segment s : map) {
					if (s.intersects(start, end)) {
						if (s.start < start) {
							map.add(new Segment(s.start, start - 1));
						}
						if (s.end > end) {
							map.add(new Segment(end + 1, s.end));
						}
						s.makeInvalid();
					}
				}
			}
			int total = 0;
			for (Segment s : map) {
				total += s.getTotalSegments();
			}
			writer.write(Integer.toString(total));
			writer.write(System.lineSeparator());
		}



		writer.close();
		reader.close();
	}

	static class Segment {
		public int start = 0;
		public int end = 0;
		public boolean invalid = false;

		public Segment(int start, int end) {
			this.start = start;
			this.end = end;
		}

		public int getTotalSegments() {
			// System.out.println(start);
			// System.out.println(end);
			// System.out.println((end - start + 1) * (end - start + 2) / 2);
			if (invalid)
				return 0;
			return (end - start + 1) * (end - start + 2) / 2;
		}

		public boolean intersects(int sStart, int sEnd) {
			// if(start == s.start && end == s.end)
			// return true;
			// if(start >= s.start && start <= s.end && end >= s.end) {
			// start = s.start;
			// return true;
			// }
			// if(start <= s.start && end <= s.end && end >= s.start) {
			// end = s.end;
			// return true;
			// }
			// if(start >= s.start && end <= end)
			// return true;
			// return false;
			return end >= sStart && start <= sEnd;
		}

		public void makeInvalid() {
			invalid = true;
			start = -1;
			end = -1;
		}
	}
}
